# -*- coding: utf-8 -*-

# with open('webNlg_new.ttl','r') as f:

import re
import os
import tqdm
 
def inital_processing(file):
    x = False
    same = 0
    stmt = 0
    with open(file,'rt') as file: # Use file to refer to the file object
        output_file = "temp.ttl"
        with open(output_file,'wt') as outfile:
            for line in file.readlines():
                if "rdf:predicate" in line:
                    stmt += 1
                    replaced = re.sub('reldr', 'reldp', line)
                    outfile.write(replaced)
                
                elif ":sameAs" in line:
                    outfile.write("    owl:sameAs dbr:"+line.split(' ')[-2].split(':')[1].title()+" "+line.split(' ')[-1])
                    same += 1
                elif line.strip() == "":
                    x = False
                    outfile.write("\n")
                elif  "rdf:Property ;" in line:
                    x = True
                    replaced = re.sub('reldr', 'reldp', line)
                    outfile.write(replaced)
                elif x:
                    replaced = re.sub('reldr', 'reldp', line)
                    outfile.write(replaced)
                else:
                    outfile.write(line)
    return output_file, stmt,same

def final_processing(file,f):
    x = False
    temp = ""
    with open(file,'rt') as file: # Use file to refer to the file object
        output_file = f
        with open("new_dumps_16/"+output_file,'wt') as outfile:
            outfile.write("@prefix reldp: <http://reld.dice-research.org/property/> .\n")
            for line in file.readlines():
                
                if line.strip() == "":
                    x = False
                    outfile.write("\n")
                elif  "rdf:Property," in line:
                    x = True
                    temp = line
                    replaced = re.sub('reldr', 'reldp', line)
                    replaced = re.sub(',',';',replaced)
                    outfile.write(replaced)
                elif x:
                    if 'rdfs:Resource' in line:
                        replaced = re.sub('rdf:Property,','rdfs:Resource ;',temp)
                        outfile.write(replaced)
                    if 'prov:Entity' in line:
                        replaced = re.sub('rdf:Property,','prov:Entity ;',temp)
                        outfile.write(replaced)
                    
               
                else:
                    outfile.write(line)                

def main():
    count_stament = 0
    sameAs = 0
    filenames = os.listdir('05_12_22_dumps')
    for f in tqdm(filenames):
        file_temp,stmt,same = inital_processing('05_12_22_dumps/'+f)
        count_stament += stmt
        sameAs += same
        final_processing(file_temp,f)
        os.remove('temp.ttl')
        print(f'In {f}, total statments = {count_stament} and sameAs = {sameAs}')
       
   

if __name__ == "__main__":
    main()

